#ifndef _FlowFieldViewer_h
#define _FlowFieldViewer_h

#include <QWidget>
#include <QAction>
#include <QToolBar>
#include <QScrollArea>
#include <QVBoxLayout>
#include "ImageViewer.h"
#include "Image.h"

class FlowFieldViewer: public QWidget
{
	Q_OBJECT
public:
	FlowFieldViewer(QWidget *parent = 0, Qt::WFlags flags = 0);
	~FlowFieldViewer(void);
	void createActions();
protected:
	void resizeEvent(QResizeEvent *event);
public slots:
	void loadImage(const QImage& image);
	void loadImage(const QImage& image1,const QImage& image2);
	void loadImage(const QImage& image1,const QImage& image2,const DImage& vx,const DImage& vy);
	void enforceUpdate(){pImageViewer->update();};
	void reset(){pImageViewer->reset();update();};

	void generatingStrokes(bool gstrokes){genStrokes=gstrokes;};
private slots:
	void setDisplayAnimation();
	void setDisplayDifference();
	void setDisplayVx();
	void setDisplayVy();
private:
	ImageViewer* pImageViewer;
	QScrollArea* scrollArea;
	QVBoxLayout* vLayout;
	QAction* zoomInAct;
	QAction* zoomOutAct;
	QAction* normalSizeAct;
	QAction* dispAnimationAct;
	QAction* dispDifferenceAct;
	QAction* dispVxAct;
	QAction* dispVyAct;
	QToolBar* toolBar;
	bool genStrokes;
};


#endif