#ifndef _MagViewer_h
#define _MagViewer_h

#include <QWidget>
#include <QImage>
#include <QVector>
#include <QBasicTimer>

// the class to show the magnified local image patches

class MagViewer: public QWidget
{
	Q_OBJECT
private:
	const QImage *pRefImage1,*pRefImage2;
	int m_WinSize,m_Interval,x0,y0;
	QList<QImage> m_ImageList1,m_ImageList2;
	QList<double> m_ScaleList;
	QPointF m_Point1,m_Point2;

	QBasicTimer timer;
	unsigned int steps;
protected:
	virtual void paintEvent(QPaintEvent *event);
	 virtual void timerEvent(QTimerEvent *event);
public:
	MagViewer(QWidget *parent = 0, Qt::WFlags flags = 0);
	~MagViewer(void);
	void GenerateSubImages();
	void reset();
public slots:
	void updatePoints(const QPointF& point1,const QPointF& point2);
	void loadImages(const QImage* refImage1,const QImage* refImage2);
};

#endif