#ifndef _MyPreference_h
#define _MyPreference


#include <QString>
//--------------------------------------------------------------------------------------------
// class that defines system parameters
//--------------------------------------------------------------------------------------------
class MyPreference
{
public:
	MyPreference(void);
	~MyPreference(void);
public:
	static double DefaultContourDistance; // a big number
	static double Threshold_PointDistance;
	static double Threshold_LineDistance;
	static double Threshold_ContourDistance;
	static double Threshold_CentroidDistance;
	static double Threshold_BoundingBox;
	static double Threshold_OccludingAreaRatio;
	static double Threshold_MaxTrackingVelocity;
	static double Threshold_MaxTrackingAcceleration;
	static double Threshold_StrokePointDistance;
	static QString DefaultLayerName;
	static int nPyrdLevels;
	static int minStrokeLength;
	static int maxStrokeLength;
	static int startStrokeWidth;
	static int endStrokeWidth;
	static bool useImageColor;
	static bool isGuideStroke;
	static bool paintOccludedRegions;
	static bool startInOccludedRegions;
	static bool fillEmptyRegions;
	static bool fillColorDifference;
	static bool reverseDirections;
	static float strokeDensity;
	static int magnitudeThreshold;
	static double Threshold_ColorDifference;
	static double Threshold_Edge;
	static int fixedOrientationFactor;
	static int boundaryFactor;
	static int imageGradientFactor;
	static int userStrokesFactor;
	static double fixedMovementRate;
	static int fadeRate;
	static int minStrokeScale;
	static int maxStrokeScale;
	static int fillFramesForward;
	static int fillFramesBackward;
	static int maxFrames;
	static int minFrames;
	static double colorUpdate;
	static double followStrokesFactor;
	static double followGradientFactor;
	static double followFlowFactor;
	static double orientationFactor;
	static double coherenceFactor;
	static double rigidityFactor;
	static double colorFactor;
	static double densityFactor;
	static int maxAngle;
	static int maxStrokeAngle;
	static int maxStrokes;
	static double boundaryBlur;
	static double radiusFactor;
	static bool addVisibleToStrokeLayer;
	static bool optimizeStrokes;
	static double coherenceAngleSigma;
	static double rigidityAngleSigma;


	static float rightColorWidth;
	static float leftColorWidth;
	static float rightColorAlpha;
	static float leftColorAlpha;

	static double magWeight;
	static double distWeight;


	static bool optimizeStrokeWidths;
	static double oswColorFactor;
	static double oswCoherenceFactor;
	static double oswRegularizationFactor;
	static double oswGrowFactor;
	static double oswEdgeFactor;


};

#endif