#ifndef _OpticalFlowBidir_h
#define _OpticalFlowBidir_h

#include "OpticalFlow.h"
#include "Image.h"

class OpticalFlowBidir: public OpticalFlow
{
private:
	static bool IsThinPlate;
	static double m_Eta;
	static DImage imdx,imdy,imdt,immask;
	static DImage uu,vv,ux,uy,vx,vy,Phi_1st,Psi_1st,imdxy,imdx2,imdy2,imdtdx,imdtdy;
	static DImage ImDxy,ImDx2,ImDy2,ImDtDx,ImDtDy;
	static DImage A11,A12,A22,b1,b2;
	static DImage foo1,foo2;
	static DImage warpur,warpvr,urdx,urdy,vrdx,vrdy;
	static DImage UU,VV,UV,UT,VT;
public:
	static void SetThinPlate(bool isthinplate=false){IsThinPlate=isthinplate;};
	static void setEta(double eta){m_Eta=eta;};
public:
	OpticalFlowBidir(void);
	~OpticalFlowBidir(void);
	static void FlowBidirIRLS(DImage& du,DImage& dv,const DImage& imdx,const DImage& imdy,const DImage& imdt,const DImage Mask,
										 const DImage& u,const DImage& v,const DImage ur,const DImage vr,
										 double alpha,double gamma,int nIRLSIterations,int nCGIterations);
	//static void Coarse2FineFlowBidir(DImage& vx1,DImage& vy1,DImage& warpI2,DImage& vx2,DImage& vy2,DImage& warpI1,
	//													const DImage& Im1,const DImage& Im2,double alpha,double gamma,double ratio,int minWidth,int nIterations,int nIRLSIterations,int nCGIterations);
	static void Coarse2FineFlowBidir(DImage& vx1,DImage& vy1,DImage& warpI2,DImage& vx2,DImage& vy2,DImage& warpI1,
														const DImage& Im1,const DImage& Im2,const DImage& Mask1,const DImage& Mask2,
														double alpha,double gamma,double ratio,int minWidth,int nIterations,int nIRLSIterations,int nCGIterations);
};

#endif