
#ifndef _Point_h
#define _Point_h

#include <math.h>
#include <assert.h>

class Point{
private:
	float _x,_y;
public:
	Point(){_x=_y=0;}
	Point(float x,float y){_x=x;_y=y;}
	inline float x() const{return _x;}
	inline float y() const{return _y;}
	inline void setX(float x){_x=x;}
	inline void setY(float y){_y=y;}

    Point operator+(const Point & v) const { return Point(_x+v.x(),_y+v.y()); }
    Point operator-(const Point & v) const { return Point(_x-v.x(),_y-v.y()); }
    Point operator*(float v) const { return Point(_x*v,_y*v); }
    Point operator/(float v) const { return Point(_x/v,_y/v); }

};

/*
struct PointR : public Point
{
private:
	float _r;
public:

  PointR() { };
  PointR(float x,float y,float r) : Point(x,y) { this->_r = r; }
  //PointR(const PointR & v) : Point(v.x(),v.y()), r(v.r()) {  }
 // Point& operator=(const PointR & v) { setX(v.x());setY(v.y());_r=v.r(); return *this; }
  inline float r()const{return _r;}
  PointR operator+(const PointR & v) const { return PointR(x()+v.x(),y()+v.y(),r()+v.r());}
  PointR operator-(const PointR & v) const { return PointR(x()-v.x(),y()-v.y(),r()-v.r());}
  PointR operator*(float v) const { return PointR(x()*v,y()*v,_r*v); }
  PointR operator/(float v) const { return PointR(x()/v,y()/v,_r/v); }
  PointR operator-() const { return PointR(-x(),-y(),-_r); }
  bool operator==(const PointR & v) const { return x() == v.x() && y() == v.y() && _r == v.r(); }

  
  PointR & operator+=(const PointR & v) { setX(x() + v.x());setY(y() + v.y());_r+=v.r();return *this;}
  float L2sqr() const { return x()*x()+y()*y(); }
  float L2() const { return sqrt(x()*x()+y()*y()); }
};

*/

#endif
