#ifndef _ReduceFrameRange_h
#define _ReduceFrameRange_h

#include <QDialog>
#include <QWidget>
#include <QSpinBox>
#include <QLabel>
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QPushButton>

class ReduceFrameRange: public QDialog
{
	Q_OBJECT

private:
	int m_NumFrames;
	int m_StartFrame,m_EndFrame;
	
	QSpinBox *startFrameSpinBox;
	QSpinBox *endFrameSpinBox;
	QLabel* startLabel;
	QLabel* endLabel;

	QPushButton* doneButton;
	QPushButton* cancelButton;
	
	QHBoxLayout* layoutSpin;
	QHBoxLayout* layoutButton;
	QVBoxLayout* layout;
public:
	ReduceFrameRange(QWidget* parent,int numFrames);
	~ReduceFrameRange(void);
	int startFrame() const {return m_StartFrame;};
	int endFrame() const {return m_EndFrame;};
private slots:
	void startFrameChanged(int);
	void endFrameChanged(int);
};

#endif