#ifndef _SortQueue_h
#define _SortQueue_h
#include "Point.h"
/*
class Point{
private:
	int _x,_y;
public:
	Point(){_x=_y=0;};
	Point(int x,int y){_x=x;_y=y;};
	inline int x() const{return _x;};
	inline int y() const{return _y;};
	inline void setX(int x){_x=x;};
	inline void setY(int y){_y=y;};
};
*/

template <class T>
class SortQueue
{
private:
	double* pScore;
	T* pValue;
	int queueLength,nElement;
	bool IsAscend;
public:
	SortQueue(void);
	SortQueue(int length);
	~SortQueue(void);
	void clear();
	void allocate(int length);
	void reset(){nElement=0;};
	void Push(double score,const T& val);
	int num() const{return nElement;};
	int length() const{return queueLength;};
	void setAscend(bool isAscend=true) {IsAscend=isAscend;};
	const T& operator[](int index) const {return pValue[index];};
	const double score(int index) const {return pScore[index];};
};

template <class T>
SortQueue<T>::SortQueue(void)
{
	queueLength=0;
	nElement=0;
	pScore=NULL;
	pValue=NULL;
	IsAscend=true;
}

template <class T>
SortQueue<T>::SortQueue(int length)
{
	queueLength=length;
	nElement=0;
	pScore=new double[queueLength];
	pValue=new T[queueLength];
	IsAscend=true;
}

template <class T>
SortQueue<T>::~SortQueue(void)
{
	clear();
}

template <class T>
void SortQueue<T>::clear()
{
	if(pScore!=NULL)
		delete pScore;
	if(pValue!=NULL)
		delete []pValue;
	pScore=NULL;
	pValue=NULL;
}

template <class T>
void SortQueue<T>::allocate(int length)
{
	nElement=0;
	if(queueLength==length)
		return;
	clear();
	queueLength=length;
	pScore=new double[queueLength];
	pValue=new T[queueLength];
}

template <class T>
void SortQueue<T>::Push(double score, const T& val)
{
	if(nElement==0)
	{
		pScore[0]=score;
		pValue[0]=val;
		nElement=1;
		return;
	}
	int i,j;
	for(i=nElement-1;i>=0;i--)
		if((IsAscend && pScore[i]<score) || (!IsAscend && pScore[i]>score))
			break;
	if(i==nElement-1) // there is no need of going into the queue
	{
		if(nElement<queueLength)
		{
			pScore[nElement]=score;
			pValue[nElement]=val;
			nElement++;
		}
		return;
	}
	// now shift the queue
	for(j=__min(nElement,queueLength-1);j>i+1;j--)
	{
		pValue[j]=pValue[j-1];
		pScore[j]=pScore[j-1];
	}
	if(nElement<queueLength)
		nElement++;
	pScore[j]=score;
	pValue[j]=val;
}



#endif