#ifndef STROKEPROPERTIES_H
#define STROKEPROPERTIES_H


#include <QColor>
#include <QFile>
#include <QString>
#include "XMLWriter.h"

class StrokeProperties
{

public:

	float startRadius;
	float endRadius;
	//float scale;
	int texture;
	QString textureFilename;
	bool useImageColor;
	
	QColor color;
	QColor initColor;
	int hueOffset, valueOffset, saturationOffset;
	float alpha;
	//int layer;

	bool isGuide;
	bool isColor;
	bool isSeed;
	bool isVisible;
	bool isFill;



	StrokeProperties();
	StrokeProperties(int startRadius, int endRadius, int texture);
	~StrokeProperties();
	void copyData(const StrokeProperties& strokeProperties);
	StrokeProperties& operator=(const StrokeProperties& strokeProperties);


	bool writeStrokeProperties(QFile& file) const;
	bool readStrokeProperties(QFile& file);

	void updateStrokeProperty(QString prop, QString val);

	/*
	bool writeXML(XmlWriter& xw) const;
	bool readXML(XmlWriter& xw);
	*/

};

#endif